package ctbrec.recorder.server;

import static javax.servlet.http.HttpServletResponse.*;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONArray;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import ctbrec.Config;
import ctbrec.Settings;

public class ConfigServlet extends AbstractCtbrecServlet {

    private static final Logger LOG = LoggerFactory.getLogger(ConfigServlet.class);
    private Config config;
    private Settings settings;

    public enum DataType {
        STRING,
        BOOLEAN,
        INTEGER,
        DOUBLE
    }

    public ConfigServlet(Config config) {
        this.config = config;
        this.settings = config.getSettings();
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //        try {
        //            boolean authenticated = checkAuthentication(req, body(req));
        //            if (!authenticated) {
        //                resp.setStatus(SC_UNAUTHORIZED);
        //                String response = "{\"status\": \"error\", \"msg\": \"HMAC does not match\"}";
        //                resp.getWriter().write(response);
        //                return;
        //            }
        //        } catch (InvalidKeyException | NoSuchAlgorithmException | IllegalStateException e) {
        //            throw new ServletException(e);
        //        }

        resp.setStatus(SC_OK);
        resp.setContentType("application/json");

        JSONArray json = new JSONArray();
        addParameter("httpPort", "HTTP port", DataType.INTEGER, settings.httpPort, json);

        resp.getWriter().print(json.toString(2));
        LOG.debug("GET {} {}", req.getRequestURI(), req.getRequestURL());
    }

    private void addParameter(String key, String name, DataType type, Object value, JSONArray json) {
        JSONObject param = new JSONObject();
        param.put("key", key);
        param.put("name", name);
        param.put("type", type);
        param.put("value", value);
        json.put(param);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        resp.setStatus(SC_OK);
        resp.setContentType("application/json");
        LOG.debug("POST");
    }
}
